# These macros reflect the locations and user Apache is configured to
# run with and as on RHL 7.x.
%define contentdir /var/www
%define cgiuser    apache
%define cgiuserid  48
%define cgigroup   apache
%define cgigroupid 48
%define _user       mailman
%define userid     41
%define _group      mailman
%define groupid    41
%define mailgroup  mail
%define mailgid    12

Summary: Mailing list manager with built in web access.
Name: mailman
Version: 2.1.3
Release: 1
Epoch: 13
Group: Applications/Internet
Source0: ftp://ftp.gnu.org/pub/gnu/mailman/mailman-%{version}.tar.gz
Source1: mm_cfg.py
Source2: mailman-2.1-initscript
Source3: mailman-README.REDHAT
Patch0: http://www.openinfo.co.uk/mailman/patches/444879/indexing-2.1.3-0.1.patch
Patch1: http://www.openinfo.co.uk/mailman/patches/444884/htdig-2.1.3-0.4.patch
Patch2: http://www.openinfo.co.uk/mailman/patches/644797/exitstatus-2.1.3-0.1.patch
Patch3: http://www.openinfo.co.uk/mailman/patches/644810/mailer-2.1.3-0.2.patch
Patch4: http://www.openinfo.co.uk/mailman/patches/760567/modinc-2.1.3-0.1.patch
Patch5: http://www.openinfo.co.uk/mailman/patches/777444/grpsec-2.1.3-0.1.patch
Patch6: http://www.openinfo.co.uk/mailman/patches/820723/mhonarc-2.1.3-06.patch
Patch7: http://www.openinfo.co.uk/mailman/patches/835332/fixarchiver-2.1.3-0.1.patch
License: GPL
URL: http://www.list.org/
BuildRoot: %{_tmppath}/%{name}-root
Prereq: shadow-utils, /usr/bin/newaliases, /usr/bin/crontab
Requires: webserver, python >= 1.5.2, mktemp

%description 
Mailman is software to help manage email discussion lists, much like
Majordomo and Smartmail. Unlike most similar products, Mailman gives
each mailing list a web page, and allows users to subscribe,
unsubscribe, etc. over the web. Even the list manager can administer
his or her list entirely from the web. Mailman also integrates most
things people want to do with mailing lists, including archiving, mail
<-> news gateways, and so on.

When the package has finished installing, you will need to:

* Run /var/mailman/bin/mmsitepass 
  to set the mailman administrator password.
* Edit /var/mailman/Mailman/mm_cfg.py 
  to customize mailman's configuration for your site.
* Modify the sendmail configuration to ensure that it is running and
  accepting connections from the outside world (to ensure that it runs,
  set "DAEMON=yes" in /etc/sysconfig/sendmail, ensuring that it accepts
  connections from the outside world may require modifying
  /etc/mail/sendmail.mc and regenerating sendmail.cf), and
* Add these lines:
  ScriptAlias /mailman/ /var/mailman/cgi-bin/
  Alias /pipermail/ /var/mailman/archives/public/
  <Directory /var/mailman/archives>
    Options +FollowSymlinks
  </Directory>
  to /etc/httpd/conf/httpd.conf to configure your web server.

Users upgrading from previous releases of this package may need to
move their data or adjust the configuration files to point to the
locations where their data is.

%prep

%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
cp -rp %{SOURCE3} README.REDHAT
aclocal
autoconf

%build
CFLAGS="$RPM_OPT_FLAGS"; export CFLAGS
MAILMAN_UID=%{userid} \
MAILMAN_GID=%{groupid} \
MAIL_GID=%{mailgid} \
CGI_UID=%{cgiuserid} \
CGI_GID=%{cgigroupid} \
./configure \
	--prefix=%{_var}/mailman \
	--with-var-prefix=%{_var}/mailman \
	--with-python=%{__python} \
	--with-username=%{_user} \
	--with-groupname=%{_group} \
	--with-mail-gid=%{mailgroup} \
	--with-cgi-id=%{cgiuser} \
	--with-cgi-gid=%{cgigroup} \
	--without-permcheck \
	--with-mailhost=mail \
	--with-urlhost=lists
cp %{SOURCE1} Mailman/mm_cfg.py.dist
make
	
%install
rm -fr $RPM_BUILD_ROOT
make install prefix=$RPM_BUILD_ROOT%{_var}/mailman var_prefix=$RPM_BUILD_ROOT%{_var}/mailman

#find $RPM_BUILD_ROOT%{_var}/mailman -name "*.pyc" -exec rm -fv '{}' ';'
#python -c 'from compileall import *; compile_dir("'$RPM_BUILD_ROOT'%{_var}/mailman/Mailman",10,"%{_var}/mailman/Mailman")'

mkdir -p $RPM_BUILD_ROOT%{contentdir}/icons
cp misc/*.jpg misc/*.png $RPM_BUILD_ROOT%{contentdir}/icons

mkdir -p $RPM_BUILD_ROOT/etc/smrsh
ln -s %{_var}/mailman/mail/mailman $RPM_BUILD_ROOT/etc/smrsh/mailman

mkdir -p $RPM_BUILD_ROOT/etc/init.d
install -m755 %{SOURCE2} $RPM_BUILD_ROOT/etc/init.d/mailmanctl

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/files.%{name}

%pre
/usr/sbin/useradd -s /bin/false -c "GNU Mailing List Manager" -d %{_var}/mailman -M -r -u 41 mailman 2> /dev/null || :

%post
if [ ! -f /var/spool/cron/mailman ]; then
  crontab -u mailman %{_var}/mailman/cron/crontab.in
fi
if ! grep -q "mailman-owner" /etc/aliases 2> /dev/null ; then
  cat >> /etc/aliases << EOF
# mailman aliases
mailman: postmaster
mailman-owner: mailman
EOF
  /usr/bin/newaliases > /dev/null 2>&1 || :
fi

%postun
if [ $1 = 0 ]; then
  crontab -u mailman -r
  TMPFILE=`mktemp /etc/aliasesXXXXXX`
  egrep -E -v 'mailman aliases|mailman:|mailman-owner:' /etc/aliases >${TMPFILE}
  mv ${TMPFILE} /etc/aliases
  /usr/bin/newaliases > /dev/null 2>&1 || :
fi

%files
%defattr(-,root,root)
%doc ACKNOWLEDGMENTS BUGS FAQ NEWS README README.LINUX TODO UPGRADING INSTALL
%doc gnu-COPYING-GPL README.REDHAT README.BSD README.CONTRIB README.EXIM
%doc README-I18N.en README.MACOSX README.NETSCAPE README.POSTFIX
%doc README.QMAIL README.SENDMAIL README.USERAGENT INSTALL.htdig-mm
%attr(0644,root,root) %{contentdir}/icons/*
%dir %{_var}/mailman
%config %{_var}/mailman/Mailman
%config /etc/smrsh/mailman
%attr(2775,root,mailman) %{_var}/mailman/archives/
%dir %{_var}/mailman/bin
%attr(2755,root,mailman) %{_var}/mailman/bin/*
%dir %{_var}/mailman/cgi-bin
%attr(2755,root,mailman) %{_var}/mailman/cgi-bin/*
%attr(2755,root,mailman) %{_var}/mailman/cron/
%attr(2775,root,mailman) %{_var}/mailman/data/
%attr(2775,root,mailman) %{_var}/mailman/lists/
%attr(2775,root,mailman) %{_var}/mailman/tests/
%attr(2775,root,mailman) %{_var}/mailman/pythonlib/
%attr(2775,root,mailman) %{_var}/mailman/locks/
%attr(2775,root,mailman) %{_var}/mailman/logs/
%attr(2775,root,mailman) %{_var}/mailman/mail/
%attr(2775,root,mailman) %{_var}/mailman/qfiles/
%attr(2775,root,mailman) %{_var}/mailman/messages/
%attr(2775,root,mailman) %{_var}/mailman/icons/
%dir %{_var}/mailman/scripts/
%attr(2755,root,mailman) %{_var}/mailman/scripts/*
%config %{_var}/mailman/templates
/etc/init.d/mailmanctl

%changelog
* Mon Nov 10 2003 Rich West <Rich.West@wesmo.com
- Updated to MM 2.1.3
- Updated all of the htdig patches accordingly.

* Thu Aug 07 2003 Rich West <Rich.West@wesmo.com>
- Integrated htdig patches for searching. See http://www.openinfo.co.uk/

* Mon May 19 2003 Rich West <Rich.West@wesmo.com>
- Updated to 2.1.2

* Thu Mar 04 2003 Rich West <Rich.West@wesmo.com>
- Updated to 2.1.1

* Thu Jan 02 2003 Rich West <Rich.West@wesmo.com>
- Updated to 2.1
- Removed the RH patch as it was obsolete.
- Removed the python compile lines since it is now integrated into the make
  install process.
- Updated smrsh wrapper script name
- Updated to reflect the new qrunner mailmanctl script
- Created /etc/init.d/mailmanctl script to properly redirect to
  /var/mailman/mail/mainmanctl.
- Removed the additional README.REDHAT as it is now part of the release.
- Included all of the README.* files.

* Thu Apr 04 2002 Rich West <Rich.West@wesmo.com>
- Updated to 2.0.9

* Wed Jan 16 2002 Rich West <Rich.West@wesmo.com>
- Updated to 2.0.8

* Sun Dec 09 2001 Rich West <Rich.West@wesmo.com>
- rebuild using standard "apache" user.

* Wed Nov 14 2001 Rich West <Rich.West@wesmo.com>
- update to 2.0.7

* Wed Jul 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.6

* Mon Jun 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- code in default user/group names/IDs

* Wed May 30 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.5
- change the default hostname from localhost to localhost.localdomain in the
  default configuration
- chuck configuration file settings other than those dependent on the host name
  (the build system's host name is not a good default)  (#32337)

* Tue Mar 13 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.3

* Tue Mar  6 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.2

* Wed Feb 21 2001 Nalin Dahyabhai <nalin@redhat.com>
- patch from Barry Warsaw (via mailman-developers) to not die on
  broken Content-Type: headers

* Tue Jan  9 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.1

* Wed Dec  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0 final release
- move the data to %{_var}

* Fri Oct 20 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta 6

* Thu Aug  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- add note about adding FollowSymlinks so that archives work

* Wed Aug  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- make the default owner root again so that root owns the docs
- update to 2.0beta5, which fixes a possible security vulnerability
- add smrsh symlink

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Wed Jul 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta4
- change uid/gid to apache.apache to match apache (#13593)
- properly recompile byte-compiled versions of the scripts (#13619)
- change mailman alias from root to postmaster

* Sat Jul  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to beta3
- drop bugs and arch patches (integrated into beta3)

* Tue Jun 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- move web files to reside under %{contentdir}
- move files from /usr/share to %{_datadir}
- integrate spot-fixes from mailman lists via gnome.org

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild for Power Tools

* Wed May 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- Update to 2.0beta2 to pick up security fixes.
- Change Requires: python to list >= 1.5.2

* Mon Nov  8 1999 Bernhard Rosenkrnzer <bero@redhat.com>
- 1.1

* Tue Sep 14 1999 Preston Brown <pbrown@redhat.com>
- 1.0 final.

* Tue Jun 15 1999 Preston Brown <pbrown@redhat.com>
- security fix for cookies
- moved to /usr/share/mailman

* Fri May 28 1999 Preston Brown <pbrown@redhat.com>
- fix up default values.

* Fri May 07 1999 Preston Brown <pbrown@redhat.com>
- modifications to install scripts

* Thu May 06 1999 Preston Brown <pbrown@redhat.com>
- initial RPM for SWS 3.0
